package com.yhy.module.core.service.workbench;

import com.yhy.module.core.controller.admin.workbench.vo.WbProjectTreeRespVO;
import com.yhy.module.core.controller.admin.workbench.vo.WbProjectTreeSaveReqVO;
import com.yhy.module.core.controller.admin.workbench.vo.WbProjectTreeSwapSortReqVO;
import java.util.List;
import javax.validation.Valid;

/**
 * 工作台项目管理树 Service 接口
 *
 * @author yhy
 */
public interface WbProjectService {

    /**
     * 创建节点（目录或项目）
     *
     * @param createReqVO 创建信息
     * @return 节点ID
     */
    Long createNode(@Valid WbProjectTreeSaveReqVO createReqVO);

    /**
     * 更新节点
     *
     * @param updateReqVO 更新信息
     */
    void updateNode(@Valid WbProjectTreeSaveReqVO updateReqVO);

    /**
     * 删除节点
     *
     * @param id 节点ID
     */
    void deleteNode(Long id);

    /**
     * 获取节点详情
     *
     * @param id 节点ID
     * @return 节点详情
     */
    WbProjectTreeRespVO getNode(Long id);

    /**
     * 获取项目管理树（树形结构）
     *
     * @return 树形结构
     */
    List<WbProjectTreeRespVO> getTree();

    /**
     * 交换排序
     *
     * @param swapReqVO 交换信息
     */
    void swapSort(@Valid WbProjectTreeSwapSortReqVO swapReqVO);

    /**
     * 归档项目
     *
     * @param id 项目节点ID
     */
    void archiveProject(Long id);

    /**
     * 将项目保存至历史库
     *
     * @param projectId 项目节点ID
     */
    void saveToHistoryLibrary(Long projectId);

    /**
     * 从历史库撤销项目
     *
     * @param projectId 项目节点ID
     */
    void removeFromHistoryLibrary(Long projectId);
}
